diff --git a/fs/buffer.c b/fs/buffer.c
index 1f0f72b76fc2a..7adf0af7530ba 100644
--- a/fs/buffer.c
+++ b/fs/buffer.c
@@ -2213,7 +2213,8 @@ EXPORT_SYMBOL(generic_write_end);
  * Returns true if all buffers which correspond to a file portion
  * we want to read are uptodate.
  */
-int block_is_partially_uptodate(struct page *page, unsigned long from,
+int block_is_partially_uptodate(struct address_space *__mapping,
+				struct page *page, unsigned long from,
 					unsigned long count)
 {
 	unsigned block_start, block_end, blocksize;
diff --git a/fs/iomap/buffered-io.c b/fs/iomap/buffered-io.c
index 091f6656f3d6b..c2c8b3f173443 100644
--- a/fs/iomap/buffered-io.c
+++ b/fs/iomap/buffered-io.c
@@ -449,8 +449,9 @@ EXPORT_SYMBOL_GPL(iomap_readahead);
  * we want to read within the page are uptodate.
  */
 int
-iomap_is_partially_uptodate(struct page *page, unsigned long from,
-		unsigned long count)
+iomap_is_partially_uptodate(struct address_space *__mapping,
+			    struct page *page, unsigned long from,
+			    unsigned long count)
 {
 	struct iomap_page *iop = to_iomap_page(page);
 	struct inode *inode = page->mapping->host;
diff --git a/fs/iomap/seek.c b/fs/iomap/seek.c
index 107ee80c35683..3f09cc0979a4a 100644
--- a/fs/iomap/seek.c
+++ b/fs/iomap/seek.c
@@ -49,7 +49,7 @@ page_seek_hole_data(struct inode *inode, struct page *page, loff_t *lastoff,
 	for (off = 0; off < PAGE_SIZE; off += bsize) {
 		if (offset_in_page(*lastoff) >= off + bsize)
 			continue;
-		if (ops->is_partially_uptodate(page, off, bsize) == seek_data) {
+		if (ops->is_partially_uptodate(MAPPING_NULL, page, off, bsize) == seek_data) {
 			unlock_page(page);
 			return true;
 		}
diff --git a/include/linux/buffer_head.h b/include/linux/buffer_head.h
index 0902142e93f0d..89a3758531889 100644
--- a/include/linux/buffer_head.h
+++ b/include/linux/buffer_head.h
@@ -223,7 +223,8 @@ int __block_write_full_page(struct inode *inode, struct page *page,
 			get_block_t *get_block, struct writeback_control *wbc,
 			bh_end_io_t *handler);
 int block_read_full_page(struct page*, get_block_t*);
-int block_is_partially_uptodate(struct page *page, unsigned long from,
+int block_is_partially_uptodate(struct address_space *__mapping,
+				struct page *page, unsigned long from,
 				unsigned long count);
 int block_write_begin(struct address_space *mapping, loff_t pos, unsigned len,
 		unsigned flags, struct page **pagep, get_block_t *get_block);
diff --git a/include/linux/fs.h b/include/linux/fs.h
index 3854da5a1bcb9..21f179e7c5daa 100644
--- a/include/linux/fs.h
+++ b/include/linux/fs.h
@@ -411,7 +411,8 @@ struct address_space_operations {
 	bool (*isolate_page)(struct page *, isolate_mode_t);
 	void (*putback_page)(struct address_space *, struct page *);
 	int (*launder_page) (struct address_space *, struct page *);
-	int (*is_partially_uptodate) (struct page *, unsigned long,
+	int (*is_partially_uptodate) (struct address_space *, struct page *,
+					unsigned long,
 					unsigned long);
 	void (*is_dirty_writeback) (struct page *, bool *, bool *);
 	int (*error_remove_page)(struct address_space *, struct page *);
diff --git a/include/linux/iomap.h b/include/linux/iomap.h
index cb4b207974756..53b94e35b02fd 100644
--- a/include/linux/iomap.h
+++ b/include/linux/iomap.h
@@ -157,8 +157,9 @@ ssize_t iomap_file_buffered_write(struct kiocb *iocb, struct iov_iter *from,
 int iomap_readpage(struct page *page, const struct iomap_ops *ops);
 void iomap_readahead(struct readahead_control *, const struct iomap_ops *ops);
 int iomap_set_page_dirty(struct address_space *__mapping, struct page *page);
-int iomap_is_partially_uptodate(struct page *page, unsigned long from,
-		unsigned long count);
+int iomap_is_partially_uptodate(struct address_space *__mapping,
+				struct page *page, unsigned long from,
+				unsigned long count);
 int iomap_releasepage(struct address_space *__mapping, struct page *page,
 		      gfp_t gfp_mask);
 void iomap_invalidatepage(struct address_space *__mapping, struct page *page,
diff --git a/mm/filemap.c b/mm/filemap.c
index faa190598cba8..951af134e0bf0 100644
--- a/mm/filemap.c
+++ b/mm/filemap.c
@@ -2244,8 +2244,8 @@ ssize_t generic_file_buffered_read(struct kiocb *iocb,
 			/* Did it get truncated before we got the lock? */
 			if (!page->mapping)
 				goto page_not_up_to_date_locked;
-			if (!mapping->a_ops->is_partially_uptodate(page,
-							offset, iter->count))
+			if (!mapping->a_ops->is_partially_uptodate(MAPPING_NULL, page,
+								   offset, iter->count))
 				goto page_not_up_to_date_locked;
 			unlock_page(page);
 		}